
_lcd_start:

;lcd16x2.c,4 :: 		void lcd_start()
;lcd16x2.c,6 :: 		PORTB &=~ (1<<PORTB1);
	IN         R27, PORTB+0
	CBR        R27, 2
	OUT        PORTB+0, R27
;lcd16x2.c,7 :: 		delay_us(1);
	LDI        R16, 5
L_lcd_start0:
	DEC        R16
	BRNE       L_lcd_start0
	NOP
;lcd16x2.c,8 :: 		PORTB |=  (1<<PORTB1);
	IN         R16, PORTB+0
	ORI        R16, 2
	OUT        PORTB+0, R16
;lcd16x2.c,9 :: 		}
L_end_lcd_start:
	RET
; end of _lcd_start

_lcd_write_cmd:

;lcd16x2.c,11 :: 		void lcd_write_cmd(char type, char inst_data)
;lcd16x2.c,13 :: 		if (type)
	TST        R2
	BRNE       L__lcd_write_cmd20
	JMP        L_lcd_write_cmd2
L__lcd_write_cmd20:
;lcd16x2.c,14 :: 		PORTB |=  (1<<PORTB0);
	IN         R16, PORTB+0
	ORI        R16, 1
	OUT        PORTB+0, R16
	JMP        L_lcd_write_cmd3
L_lcd_write_cmd2:
;lcd16x2.c,16 :: 		PORTB &=~ (1<<PORTB0);
	IN         R27, PORTB+0
	CBR        R27, 1
	OUT        PORTB+0, R27
L_lcd_write_cmd3:
;lcd16x2.c,18 :: 		PORTD = (PIND & 0x0F) | (inst_data & 0xF0);
	IN         R16, PIND+0
	MOV        R17, R16
	ANDI       R17, 15
	MOV        R16, R3
	ANDI       R16, 240
	OR         R16, R17
	OUT        PORTD+0, R16
;lcd16x2.c,19 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,20 :: 		PORTD = (PIND & 0x0F) | ((inst_data<<4) & 0xF0);
	IN         R16, PIND+0
	MOV        R17, R16
	ANDI       R17, 15
	MOV        R16, R3
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
	OR         R16, R17
	OUT        PORTD+0, R16
;lcd16x2.c,21 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,22 :: 		delay_ms(2);
	LDI        R17, 42
	LDI        R16, 142
L_lcd_write_cmd4:
	DEC        R16
	BRNE       L_lcd_write_cmd4
	DEC        R17
	BRNE       L_lcd_write_cmd4
	NOP
;lcd16x2.c,23 :: 		}
L_end_lcd_write_cmd:
	RET
; end of _lcd_write_cmd

_lcd_begin:

;lcd16x2.c,25 :: 		void lcd_begin()
;lcd16x2.c,27 :: 		DDRB  |=  (1<<DDB0) | (1<<DDB1);
	PUSH       R2
	PUSH       R3
	IN         R16, DDRB+0
	ORI        R16, 3
	OUT        DDRB+0, R16
;lcd16x2.c,28 :: 		DDRD  |=  0xF0;
	IN         R16, DDRD+0
	ORI        R16, 240
	OUT        DDRD+0, R16
;lcd16x2.c,30 :: 		PORTB &=~ ((1<<PORTB0) | (1<<PORTB0));
	IN         R27, PORTB+0
	CBR        R27, 1
	OUT        PORTB+0, R27
;lcd16x2.c,32 :: 		PORTD  = (PIND & 0x0F) | 0x30;
	IN         R16, PIND+0
	ANDI       R16, 15
	ORI        R16, 48
	OUT        PORTD+0, R16
;lcd16x2.c,34 :: 		delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_lcd_begin6:
	DEC        R16
	BRNE       L_lcd_begin6
	DEC        R17
	BRNE       L_lcd_begin6
	DEC        R18
	BRNE       L_lcd_begin6
	NOP
;lcd16x2.c,35 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,36 :: 		delay_ms(5);
	LDI        R17, 104
	LDI        R16, 229
L_lcd_begin8:
	DEC        R16
	BRNE       L_lcd_begin8
	DEC        R17
	BRNE       L_lcd_begin8
;lcd16x2.c,37 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,38 :: 		delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_lcd_begin10:
	DEC        R16
	BRNE       L_lcd_begin10
	DEC        R17
	BRNE       L_lcd_begin10
;lcd16x2.c,39 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,40 :: 		delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_lcd_begin12:
	DEC        R16
	BRNE       L_lcd_begin12
	DEC        R17
	BRNE       L_lcd_begin12
;lcd16x2.c,42 :: 		PORTD = (PIND & 0x0F) | 0x20;
	IN         R16, PIND+0
	ANDI       R16, 15
	ORI        R16, 32
	OUT        PORTD+0, R16
;lcd16x2.c,44 :: 		lcd_start();
	CALL       _lcd_start+0
;lcd16x2.c,45 :: 		delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_lcd_begin14:
	DEC        R16
	BRNE       L_lcd_begin14
	DEC        R17
	BRNE       L_lcd_begin14
;lcd16x2.c,47 :: 		lcd_write_cmd(LCD_INST , 0x2C);
	LDI        R27, 44
	MOV        R3, R27
	CLR        R2
	CALL       _lcd_write_cmd+0
;lcd16x2.c,48 :: 		lcd_write_cmd(LCD_INST , 0x08);
	LDI        R27, 8
	MOV        R3, R27
	CLR        R2
	CALL       _lcd_write_cmd+0
;lcd16x2.c,49 :: 		lcd_write_cmd(LCD_INST , 0x01);
	LDI        R27, 1
	MOV        R3, R27
	CLR        R2
	CALL       _lcd_write_cmd+0
;lcd16x2.c,50 :: 		lcd_write_cmd(LCD_INST , 0x06);
	LDI        R27, 6
	MOV        R3, R27
	CLR        R2
	CALL       _lcd_write_cmd+0
;lcd16x2.c,51 :: 		lcd_write_cmd(LCD_INST , 0x0C);
	LDI        R27, 12
	MOV        R3, R27
	CLR        R2
	CALL       _lcd_write_cmd+0
;lcd16x2.c,52 :: 		}
L_end_lcd_begin:
	POP        R3
	POP        R2
	RET
; end of _lcd_begin

_Lcd_strg:

;lcd16x2.c,54 :: 		void Lcd_strg(char *buffer, unsigned char data1)
;lcd16x2.c,57 :: 		Lcd_write_cmd(LCD_INST, data1);
	PUSH       R3
	PUSH       R2
	MOV        R3, R4
	CLR        R2
	CALL       _lcd_write_cmd+0
	POP        R2
	POP        R3
;lcd16x2.c,58 :: 		lcd_print(buffer);
	CALL       _lcd_print+0
;lcd16x2.c,60 :: 		}
L_end_Lcd_strg:
	RET
; end of _Lcd_strg

_lcd_print:

;lcd16x2.c,62 :: 		void lcd_print(char *s)
;lcd16x2.c,64 :: 		while(*s)
L_lcd_print16:
	MOVW       R30, R2
	LD         R16, Z
	TST        R16
	BRNE       L__lcd_print24
	JMP        L_lcd_print17
L__lcd_print24:
;lcd16x2.c,66 :: 		lcd_write_cmd(LCD_DATA, *s);
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R3, R16
	LDI        R27, 1
	MOV        R2, R27
	CALL       _lcd_write_cmd+0
	POP        R2
	POP        R3
;lcd16x2.c,67 :: 		s++;
	MOVW       R16, R2
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R2, R16
;lcd16x2.c,68 :: 		}
	JMP        L_lcd_print16
L_lcd_print17:
;lcd16x2.c,69 :: 		}
L_end_lcd_print:
	RET
; end of _lcd_print

lcd16x2____?ag:

L_end_lcd16x2___?ag:
	RET
; end of lcd16x2____?ag
