
#include "lcd16x2.h"

 void lcd_start()
 {
        PORTB &=~ (1<<PORTB1);
        delay_us(1);
        PORTB |=  (1<<PORTB1);
 }

 void lcd_write_cmd(char type, char inst_data)
 {
        if (type)
                PORTB |=  (1<<PORTB0);
        else
                PORTB &=~ (1<<PORTB0);

        PORTD = (PIND & 0x0F) | (inst_data & 0xF0);
        lcd_start();
        PORTD = (PIND & 0x0F) | ((inst_data<<4) & 0xF0);
        lcd_start();
        delay_ms(2);
 }

void lcd_begin()
 {
        DDRB  |=  (1<<DDB0) | (1<<DDB1);
        DDRD  |=  0xF0;

        PORTB &=~ ((1<<PORTB0) | (1<<PORTB0));

        PORTD  = (PIND & 0x0F) | 0x30;

        delay_ms(100);
        lcd_start();
        delay_ms(5);
        lcd_start();
        delay_us(100);
        lcd_start();
        delay_us(100);

        PORTD = (PIND & 0x0F) | 0x20;

        lcd_start();
        delay_us(100);

        lcd_write_cmd(LCD_INST , 0x2C);
        lcd_write_cmd(LCD_INST , 0x08);
        lcd_write_cmd(LCD_INST , 0x01);
        lcd_write_cmd(LCD_INST , 0x06);
        lcd_write_cmd(LCD_INST , 0x0C);
 }

void Lcd_strg(char *buffer, unsigned char data1)
{

Lcd_write_cmd(LCD_INST, data1);
lcd_print(buffer);

}

void lcd_print(char *s)
{
        while(*s)
        {
                lcd_write_cmd(LCD_DATA, *s);
                s++;
        }
}